blob: 35ced89ff9172947375afcb84d8926ae9db893f2 [file] [log] [blame]
garciadeblas93c61312016-09-28 15:12:48 +02001#!/bin/bash
garciadeblas38d91ee2019-11-07 16:31:23 +01002#
3# Licensed under the Apache License, Version 2.0 (the "License");
4# you may not use this file except in compliance with the License.
5# You may obtain a copy of the License at
6#
7# http://www.apache.org/licenses/LICENSE-2.0
8#
9# Unless required by applicable law or agreed to in writing, software
10# distributed under the License is distributed on an "AS IS" BASIS,
11# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12# See the License for the specific language governing permissions and
13# limitations under the License.
14#
garciadeblasd8bc5c32018-05-09 17:37:56 +020015REPOSITORY_BASE=https://osm-download.etsi.org/repository/osm/debian
garciadeblas931a5122023-10-03 17:52:02 +020016RELEASE=ReleaseFOURTEEN
garciadeblas7bcadc52020-02-02 22:40:15 +010017REPOSITORY=stable
garciadeblas931a5122023-10-03 17:52:02 +020018DOCKER_TAG="testing-daily"
garciadeblas2bf767a2021-05-19 10:54:46 +020019DEVOPS_PATH=/usr/share/osm-devops
garciadeblas93c61312016-09-28 15:12:48 +020020
garciadeblas38d91ee2019-11-07 16:31:23 +010021function usage(){
22 echo -e "usage: $0 [OPTIONS]"
garciadeblas81077ae2023-07-03 19:31:15 +020023 echo -e "Install OSM"
garciadeblas38d91ee2019-11-07 16:31:23 +010024 echo -e " OPTIONS"
garciadeblas7f1e1042020-11-30 14:07:03 +000025 echo -e " -h / --help: print this help"
26 echo -e " -y: do not prompt for confirmation, assumes yes"
garciadeblas38d91ee2019-11-07 16:31:23 +010027 echo -e " -r <repo>: use specified repository name for osm packages"
28 echo -e " -R <release>: use specified release for osm binaries (deb packages, lxd images, ...)"
29 echo -e " -u <repo base>: use specified repository url for osm packages"
30 echo -e " -k <repo key>: use specified repository public key url"
31 echo -e " -b <refspec>: install OSM from source code using a specific branch (master, v2.0, ...) or tag"
32 echo -e " -b master (main dev branch)"
33 echo -e " -b v2.0 (v2.0 branch)"
34 echo -e " -b tags/v1.1.0 (a specific tag)"
35 echo -e " ..."
garciadeblas96155042022-06-22 16:26:22 +020036 echo -e " -a <apt proxy url>: use this apt proxy url when downloading apt packages (air-gapped installation)"
garciadeblas81077ae2023-07-03 19:31:15 +020037 echo -e " -s <namespace> namespace when installed using k8s, default is osm"
garciadeblas38d91ee2019-11-07 16:31:23 +010038 echo -e " -H <VCA host> use specific juju host controller IP"
39 echo -e " -S <VCA secret> use VCA/juju secret key"
40 echo -e " -P <VCA pubkey> use VCA/juju public key file"
garciadeblas38d91ee2019-11-07 16:31:23 +010041 echo -e " -A <VCA apiproxy> use VCA/juju API proxy"
magnussonl1bbe9452020-02-25 13:43:17 +010042 echo -e " --pla: install the PLA module for placement support"
garciadeblas81077ae2023-07-03 19:31:15 +020043 echo -e " --old-sa: install old Service Assurance framework (MON, POL); do not install Airflow and Pushgateway"
44 echo -e " --ng-sa: install new Service Assurance framework (Airflow, AlertManager and Pushgateway) (enabled by default)"
garciadeblas96155042022-06-22 16:26:22 +020045 echo -e " -m <MODULE>: install OSM but only rebuild or pull the specified docker images (NG-UI, NBI, LCM, RO, MON, POL, PLA, KAFKA, MONGO, PROMETHEUS, PROMETHEUS-CADVISOR, KEYSTONE-DB, NONE)"
garciadeblas81077ae2023-07-03 19:31:15 +020046 echo -e " -o <ADDON>: ONLY (un)installs one of the addons (k8s_monitor, ng-sa)"
garciadeblas96155042022-06-22 16:26:22 +020047 echo -e " -O <openrc file path/cloud name>: Install OSM to an OpenStack infrastructure. <openrc file/cloud name> is required. If a <cloud name> is used, the clouds.yaml file should be under ~/.config/openstack/ or /etc/openstack/"
garciadeblascb129372020-11-14 23:06:42 +000048 echo -e " -N <openstack public network name/ID>: Public network name required to setup OSM to OpenStack"
garciadeblas96155042022-06-22 16:26:22 +020049 echo -e " -f <path to SSH public key>: Public SSH key to use to deploy OSM to OpenStack"
50 echo -e " -F <path to cloud-init file>: Cloud-Init userdata file to deploy OSM to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010051 echo -e " -D <devops path> use local devops installation path"
52 echo -e " -w <work dir> Location to store runtime installation"
53 echo -e " -t <docker tag> specify osm docker tag (default is latest)"
David Garcia79f4f532020-04-07 12:59:34 +020054 echo -e " -l: LXD cloud yaml file"
55 echo -e " -L: LXD credentials yaml file"
David Garcia404ae122020-04-28 11:47:55 +020056 echo -e " -K: Specifies the name of the controller to use - The controller must be already bootstrapped"
garciadeblas7f1e1042020-11-30 14:07:03 +000057 echo -e " -d <docker registry URL> use docker registry URL instead of dockerhub"
58 echo -e " -p <docker proxy URL> set docker proxy URL as part of docker CE configuration"
garciadeblas9a510862021-04-21 14:15:56 +020059 echo -e " -T <docker tag> specify docker tag for the modules specified with option -m"
garciadeblas96155042022-06-22 16:26:22 +020060 echo -e " --debug: debug mode"
garciadeblas9a510862021-04-21 14:15:56 +020061 echo -e " --nocachelxdimages: do not cache local lxd images, do not create cronjob for that cache (will save installation time, might affect instantiation time)"
garciadeblas96155042022-06-22 16:26:22 +020062 echo -e " --cachelxdimages: cache local lxd images, create cronjob for that cache (will make installation longer)"
David Garcia79f4f532020-04-07 12:59:34 +020063 echo -e " --nolxd: do not install and configure LXD, allowing unattended installations (assumes LXD is already installed and confifured)"
garciadeblas38d91ee2019-11-07 16:31:23 +010064 echo -e " --nodocker: do not install docker, do not initialize a swarm (assumes docker is already installed and a swarm has been initialized)"
65 echo -e " --nojuju: do not juju, assumes already installed"
66 echo -e " --nodockerbuild:do not build docker images (use existing locally cached images)"
67 echo -e " --nohostports: do not expose docker ports to host (useful for creating multiple instances of osm on the same host)"
68 echo -e " --nohostclient: do not install the osmclient"
69 echo -e " --uninstall: uninstall OSM: remove the containers and delete NAT rules"
70 echo -e " --source: install OSM from source code using the latest stable tag"
71 echo -e " --develop: (deprecated, use '-b master') install OSM from source code using the master branch"
garciadeblas38d91ee2019-11-07 16:31:23 +010072 echo -e " --pullimages: pull/run osm images from docker.io/opensourcemano"
garciadeblascb129372020-11-14 23:06:42 +000073 echo -e " --k8s_monitor: install the OSM kubernetes monitoring with prometheus and grafana"
74 echo -e " --volume: create a VM volume when installing to OpenStack"
garciadeblas38d91ee2019-11-07 16:31:23 +010075 echo -e " --showopts: print chosen options and exit (only for debugging)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020076 echo -e " --charmed: Deploy and operate OSM with Charms on k8s"
77 echo -e " [--bundle <bundle path>]: Specify with which bundle to deploy OSM with charms (--charmed option)"
78 echo -e " [--k8s <kubeconfig path>]: Specify with which kubernetes to deploy OSM with charms (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000079 echo -e " [--vca <name>]: Specifies the name of the controller to use - The controller must be already bootstrapped (--charmed option)"
aticig5d19ac22022-05-06 13:46:22 +030080 echo -e " [--small-profile]: Do not install and configure LXD which aims to use only K8s Clouds (--charmed option)"
garciadeblas96155042022-06-22 16:26:22 +020081 echo -e " [--lxd <yaml path>]: Takes a YAML file as a parameter with the LXD Cloud information (--charmed option)"
Dominik Fleischmann7a97a4c2020-06-04 10:52:05 +020082 echo -e " [--lxd-cred <yaml path>]: Takes a YAML file as a parameter with the LXD Credentials information (--charmed option)"
83 echo -e " [--microstack]: Installs microstack as a vim. (--charmed option)"
David Garcia4bd2bf02021-05-05 19:01:43 +020084 echo -e " [--overlay]: Add an overlay to override some defaults of the default bundle (--charmed option)"
Dominik Fleischmannc57296f2020-06-09 11:45:08 +020085 echo -e " [--ha]: Installs High Availability bundle. (--charmed option)"
garciadeblascb129372020-11-14 23:06:42 +000086 echo -e " [--tag]: Docker image tag. (--charmed option)"
87 echo -e " [--registry]: Docker registry with optional credentials as user:pass@hostname:port (--charmed option)"
garciadeblas38d91ee2019-11-07 16:31:23 +010088}
89
garciadeblasd8bc5c32018-05-09 17:37:56 +020090add_repo() {
91 REPO_CHECK="^$1"
92 grep "${REPO_CHECK/\[arch=amd64\]/\\[arch=amd64\\]}" /etc/apt/sources.list > /dev/null 2>&1
93 if [ $? -ne 0 ]
94 then
garciadeblasbd925e42018-06-14 14:32:12 +020095 need_packages_lw="software-properties-common apt-transport-https"
garciadeblas0bc87522021-10-20 22:16:17 +020096 echo -e "Checking required packages to add ETSI OSM debian repo: $need_packages_lw"
garciadeblasbd925e42018-06-14 14:32:12 +020097 dpkg -l $need_packages_lw &>/dev/null \
98 || ! echo -e "One or several required packages are not installed. Updating apt cache requires root privileges." \
garciadeblas5f420b12022-02-10 01:43:59 +010099 || sudo apt-get -qy update \
Mike Marchetti34124182018-10-16 08:22:30 -0400100 || ! echo "failed to run apt-get update" \
garciadeblasbd925e42018-06-14 14:32:12 +0200101 || exit 1
102 dpkg -l $need_packages_lw &>/dev/null \
103 || ! echo -e "Installing $need_packages_lw requires root privileges." \
104 || sudo apt-get install -y $need_packages_lw \
Mike Marchetti34124182018-10-16 08:22:30 -0400105 || ! echo "failed to install $need_packages_lw" \
garciadeblasbd925e42018-06-14 14:32:12 +0200106 || exit 1
garciadeblasbc97a012022-04-21 00:29:02 +0200107 wget -q -O OSM-ETSI-Release-key.gpg "$REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg"
108 sudo APT_KEY_DONT_WARN_ON_DANGEROUS_USAGE=1 apt-key add OSM-ETSI-Release-key.gpg \
109 || ! echo -e "Could not add GPG key $REPOSITORY_BASE/$RELEASE/OSM%20ETSI%20Release%20Key.gpg" \
110 || exit 1
garciadeblas5f420b12022-02-10 01:43:59 +0100111 sudo DEBIAN_FRONTEND=noninteractive add-apt-repository -y "$1"
garciadeblasbc97a012022-04-21 00:29:02 +0200112 sudo DEBIAN_FRONTEND=noninteractive apt-get -y update
garciadeblas429b9f82018-03-20 02:09:44 +0100113 return 0
garciadeblasd8bc5c32018-05-09 17:37:56 +0200114 fi
115
116 return 1
garciadeblas55490d42016-10-29 14:22:03 +0200117}
118
garciadeblas25e87d22020-01-31 14:27:29 +0100119clean_old_repo() {
madaviae0784f2020-01-22 16:29:19 +0530120dpkg -s 'osm-devops' &> /dev/null
madaviae0784f2020-01-22 16:29:19 +0530121if [ $? -eq 0 ]; then
madaviae0784f2020-01-22 16:29:19 +0530122 # Clean the previous repos that might exist
123 sudo sed -i "/osm-download.etsi.org/d" /etc/apt/sources.list
124fi
125}
126
garciadeblas0bc87522021-10-20 22:16:17 +0200127function configure_apt_proxy() {
128 [ -z "${DEBUG_INSTALL}" ] || DEBUG beginning of function
129 OSM_APT_PROXY=$1
130 OSM_APT_PROXY_FILE="/etc/apt/apt.conf.d/osm-apt"
131 echo "Configuring apt proxy in file ${OSM_APT_PROXY_FILE}"
132 if [ ! -f ${OSM_APT_PROXY_FILE} ]; then
133 sudo bash -c "cat <<EOF > ${OSM_APT_PROXY}
134Acquire::http { Proxy \"${OSM_APT_PROXY}\"; }
135EOF"
136 else
137 sudo sed -i "s|Proxy.*|Proxy \"${OSM_APT_PROXY}\"; }|" ${OSM_APT_PROXY_FILE}
138 fi
garciadeblas5f420b12022-02-10 01:43:59 +0100139 sudo apt-get -y update || FATAL "Configured apt proxy, but couldn't run 'apt-get update'. Check ${OSM_APT_PROXY_FILE}"
garciadeblas0bc87522021-10-20 22:16:17 +0200140 [ -z "${DEBUG_INSTALL}" ] || DEBUG end of function
141}
142
143while getopts ":a:b:r:n:k:u:R:D:o:O:m:N:H:S:s:t:U:P:A:l:L:K:d:p:T:f:F:-: hy" o; do
garciadeblas38d91ee2019-11-07 16:31:23 +0100144 case "${o}" in
Antonio Marsico75a38c72020-12-21 17:29:42 +0100145 D)
146 DEVOPS_PATH="${OPTARG}"
147 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100148 r)
149 REPOSITORY="${OPTARG}"
150 ;;
151 R)
152 RELEASE="${OPTARG}"
153 ;;
154 u)
155 REPOSITORY_BASE="${OPTARG}"
156 ;;
157 t)
garciadeblas25e87d22020-01-31 14:27:29 +0100158 DOCKER_TAG="${OPTARG}"
garciadeblas38d91ee2019-11-07 16:31:23 +0100159 ;;
garciadeblas72399e32019-11-22 10:09:40 +0100160 -)
161 [ "${OPTARG}" == "help" ] && usage && exit 0
Dominik Fleischmann5e4a7512020-03-06 14:05:06 +0100162 ;;
garciadeblas25e87d22020-01-31 14:27:29 +0100163 :)
164 echo "Option -$OPTARG requires an argument" >&2
165 usage && exit 1
166 ;;
167 \?)
168 echo -e "Invalid option: '-$OPTARG'\n" >&2
169 usage && exit 1
170 ;;
171 h)
172 usage && exit 0
173 ;;
garciadeblas38d91ee2019-11-07 16:31:23 +0100174 *)
175 ;;
176 esac
177done
178
garciadeblas25e87d22020-01-31 14:27:29 +0100179clean_old_repo
garciadeblasd8bc5c32018-05-09 17:37:56 +0200180add_repo "deb [arch=amd64] $REPOSITORY_BASE/$RELEASE $REPOSITORY devops"
garciadeblas5f420b12022-02-10 01:43:59 +0100181sudo DEBIAN_FRONTEND=noninteractive apt-get -qy update
182sudo DEBIAN_FRONTEND=noninteractive apt-get -y install osm-devops
Antonio Marsico75a38c72020-12-21 17:29:42 +0100183$DEVOPS_PATH/installers/full_install_osm.sh -R $RELEASE -r $REPOSITORY -u $REPOSITORY_BASE -D $DEVOPS_PATH -t $DOCKER_TAG "$@"